server: Better newstyle .open failure handling
[nbdkit/ericb.git] / tests / test-cache-max-size.sh
blob7e23fdde32403111c6bae406d329a4deb6ef9dda
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright (C) 2018 Red Hat Inc.
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 source ./functions.sh
34 set -e
35 set -x
37 # Check that this is a Linux-like system supporting /proc/$pid/fd.
38 requires test -d /proc/self/fd
39 requires qemu-io --version
40 # Need the stat command from coreutils.
41 requires stat --version
43 sock=`mktemp -u`
44 d=cache-max-size.d
45 rm -rf $d
46 mkdir -p $d
47 cleanup_fn rm -rf $d
48 cleanup_fn rm -f $sock
50 # Create a cache directory.
51 mkdir $d/cache
52 TMPDIR=$d/cache
53 export TMPDIR
55 # Create an empty base image.
56 truncate -s 1G $d/cache-max-size.img
58 # Run nbdkit with the caching filter and a low size limit to ensure
59 # that the reclaim code is exercised.
60 start_nbdkit -P $d/cache-max-size.pid -U $sock \
61 --filter=cache \
62 file $d/cache-max-size.img \
63 cache-max-size=10M cache-on-read=true
65 # Write > 10M to the plugin.
66 qemu-io -f raw "nbd+unix://?socket=$sock" \
67 -c "w -P 0 0 10M" \
68 -c "w -P 0 20M 10M" \
69 -c "r 20M 10M" \
70 -c "r 30M 10M" \
71 -c "w -P 0 40M 10M"
73 # We can't use ‘du’ on the cache directory because the cache file is
74 # deleted by the filter, and so is only accessible via /proc/$pid/fd.
75 # Get the /proc link to the cache file, and the size of it in bytes.
76 fddir="/proc/$( cat $d/cache-max-size.pid )/fd"
77 ls -l $fddir ||:
78 fd="$fddir/$( ls -l $fddir | grep $TMPDIR/ | head -1 | awk '{print $9}' )"
79 stat -L $fd
80 size=$(( $(stat -L -c '%b * %B' $fd) ))
82 if [ "$size" -gt $(( 11 * 1024 * 1024 )) ]; then
83 echo "$0: cache size is larger than 10M (actual size: $size bytes)"
84 exit 1